//+------------------------------------------------------------------+
//|                                                ExportLevels2.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
extern int BarsCount=150;
extern color LineColor0=Lime;
extern color LineColor1=Green;
extern color LineColor2=Yellow;
extern color LineColor3=Blue;

extern int iPrice=0;
//extern int LineCount=2;
extern int Shift=10;
double dPrice[];
string line0[7];
int OldTime=0;
double a=0,b=0,s=0;
int n=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init() {
   int i;
   a=0;
   b=0;
   s=0;
   string tmp="Line";
//   ArrayResize(line,3+LineCount*2);
   ArrayResize(dPrice,BarsCount);
   for (i=0;i<3;i++){
      line0[i]=tmp+Symbol()+"_"+i+"_"+Period()+"_"+BarsCount+"_0";
      ObjectCreate(line0[i],OBJ_TREND,0,0,0,0,0);
      ObjectSet(line0[i],OBJPROP_COLOR,LineColor1);
   }
   ObjectSet(line0[0],OBJPROP_COLOR,LineColor0);
   for (i=3;i<7;i++){
      line0[i]=tmp+Symbol()+"_"+i+"_"+Period()+"_"+BarsCount+"_0";
      ObjectCreate(line0[i],OBJ_TREND,0,0,0,0,0);
      ObjectSet(line0[i],OBJPROP_COLOR,LineColor2);
   }
   ObjectSet(line0[5],OBJPROP_COLOR,LineColor3);
   ObjectSet(line0[6],OBJPROP_COLOR,LineColor3);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   for(int i=0;i<7;i++) {
      ObjectDelete(line0[i]);
   }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
   int i,i1,i2,k,m;
   double price1,price2;
   int tmp=TimePeriod(Time[1],Period());
   if (tmp!=OldTime) {   
      OldTime=tmp;
      price1=a*(-n)+b+1.5*s;
      price2=a*(-n)+b-1.5*s;
      if (fPrice(iPrice,1)<=price1 && fPrice(iPrice,1)>=price2)
         n++;
      else 
      {
         n=Shift;
         for (i=Shift;i<BarsCount+Shift;i++) 
            dPrice[i-Shift]=fPrice(iPrice,i);
         fLine_1(dPrice,a,b,s);

         _ObjectSet(line0[0], a*BarsCount+b+0.0*s,a+b+0.0*s);
         _ObjectSet(line0[1], a*BarsCount+b+1.5*s,a+b+1.5*s);
         _ObjectSet(line0[2], a*BarsCount+b-1.5*s,a+b-1.5*s);
         _ObjectSet(line0[3], a*BarsCount+b+2.5*s,a+b+2.5*s);
         _ObjectSet(line0[4], a*BarsCount+b-2.5*s,a+b-2.5*s);
         _ObjectSet(line0[5], a*BarsCount+b+3.5*s,a+b+3.5*s);
         _ObjectSet(line0[6], a*BarsCount+b-3.5*s,a+b-3.5*s);

         }
               Comment("N=",BarsCount," Delta=",(a*(1-BarsCount))/Point/Period(),", 3*S=",s*3/Point,", n=",n);
      }
   return(0);
}

void _ObjectSet(string name, double price1, double price2) {
   ObjectSet(name, OBJPROP_TIME1, Time[BarsCount+Shift-1]);
   ObjectSet(name, OBJPROP_PRICE1, price1);
   ObjectSet(name, OBJPROP_TIME2, Time[Shift]);
   ObjectSet(name, OBJPROP_PRICE2, price2);
}

int TimePeriod(datetime Value,int iPeriod){
   if (iPeriod<Period()) iPeriod=Period();
   return(MathRound(1.0*Value/(iPeriod*60)));
}
void fLine_1(double arrayTmp[],double& a, double& b,double& s){
   double   sx0=BarsCount,sx1=0,   sx2=0,  sx3=0,  sx4=0;
   double   syx0=0,  syx1=0, syx2=0, y, x;
   double   d[]={0,0,0};
   double tmp;
   for (int i = 0; i<BarsCount;i++) {
      y=arrayTmp[i];
      x=i*1.0;
      sx1+=x;
      sx2+=x*x;
      syx0+=y;
      syx1+=y*x;
      }//for ((int x = 0; x<iPeriod;x++)

   d[0]=opr2(sx2,sx1,
             sx1,sx0);
   d[1]=opr2(syx1,sx1,
             syx0,sx0);
   d[2]=opr2(sx2,syx1,
             sx1,syx0);

   a=d[1]/d[0];
   b=d[2]/d[0];
   tmp=0;
   for (i = 0; i<BarsCount;i++) {
      y=arrayTmp[i];
      tmp+=(y-a*i-b)*(y-a*i-b);}
   s=MathSqrt(tmp/(BarsCount-1));
   
   return(0); }   //double fLine(int iPeriod,int iPrice,int i)

//  
double opr2(double a11,double a12, 
            double a21, double a22) {
   double RetVal;
   RetVal=a11*a22-a12*a21;
   return(RetVal);}

double fPrice(int CodePrice, int Shift){
   double dRetVal=0;
   switch (CodePrice) {
      case PRICE_OPEN:     dRetVal=Open[Shift]; break;
      case PRICE_HIGH:     dRetVal=High[Shift]; break;
      case PRICE_LOW:      dRetVal=Low[Shift]; break;
      case PRICE_MEDIAN:   dRetVal=(High[Shift]+Low[Shift])/2; break;
      case PRICE_TYPICAL:  dRetVal=(High[Shift]+Low[Shift]+Close[Shift])/3; break;
      case PRICE_WEIGHTED: dRetVal=(High[Shift]+Low[Shift]+Close[Shift]*2)/4; break;
      default:             dRetVal=Close[Shift];
   }
   return(dRetVal);
}